describe('Controladores módulo crear nota de pedido', function() {

    var $controler;

    beforeEach(function() {
        module('focaCrearNotaPedido');
        inject(function(_$controller_) {
            $controler = _$controller_;
        });
    });

    describe('Controlador notaPedidoCtrl crear nota de pedido', function() {

        var filter = function() {
            return function() { };
        };
        var timeout;

        beforeEach(function() {

            inject(function($timeout) {
                timeout = $timeout;
            });
        });

        it('Existe el controlador notaPedidoCtrl', function() {

            //act
            var controlador = $controler('notaPedidoCtrl', {
                $scope: {},
                $uibModal: {},
                $location: {},
                $filter: filter,
                $timeout: timeout,
                crearNotaPedidoService: {
                    getBotonera: function() { },
                    getCotizacionByIdMoneda: function() {
                        return {
                            then: function() {}
                        };
                    }
                },
                focaBotoneraLateralService: {},
                focaModalService: {},
                notaPedidoBusinessService: {},
                $rootScope: {
                    $on: function() { }
                },
                focaSeguimientoService: {},
                APP: {},
                focaLoginService: {}
            });

            //expect
            expect(typeof controlador).toEqual('object');
        });

        it('la funcion $scope.crearNotaPedido muestra alerta cuando vendedor es null', function() {

            //arrange
            var scope = {};
            var focaModalService = {
                alert: function() { }
            };

            $controler('notaPedidoCtrl', {
                $scope: scope,
                $uibModal: {},
                $location: {},
                $filter: filter,
                $timeout: timeout,
                crearNotaPedidoService: {
                    getBotonera: function() { },
                    getCotizacionByIdMoneda: function() {
                        return {
                            then: function() {}
                        };
                    }
                },
                focaBotoneraLateralService: {},
                focaModalService: focaModalService,
                notaPedidoBusinessService: {},
                $rootScope: {
                    $on: function() { }
                },
                focaSeguimientoService: {},
                APP: {},
                focaLoginService: {}
            });

            //act
            scope.notaPedido = {
                vendedor: {
                    id: null
                }
            };
            spyOn(focaModalService, 'alert');
            scope.crearNotaPedido();

            //expect
            expect(focaModalService.alert).toHaveBeenCalledWith('Ingrese Vendedor');
        });

        it('la funcion $scope.crearNotaPedido muestra alerta cuando cliente es null', function() {

            //arrange
            var scope = {};
            var focaModalService = {
                alert: function() { }
            };

            $controler('notaPedidoCtrl', {
                $scope: scope,
                $uibModal: {},
                $location: {},
                $filter: filter,
                $timeout: timeout,
                crearNotaPedidoService: {
                    getBotonera: function() { },
                    getCotizacionByIdMoneda: function() {
                        return {
                            then: function() {}
                        };
                    }
                },
                focaBotoneraLateralService: {},
                focaModalService: focaModalService,
                notaPedidoBusinessService: {},
                $rootScope: {
                    $on: function() { }
                },
                focaSeguimientoService: {},
                APP: {},
                focaLoginService: {}
            });

            scope.notaPedido = {
                vendedor: {
                    id: true
                },
                cliente:{
                    COD: false
                }
            };

            //act
            spyOn(focaModalService, 'alert');
            scope.crearNotaPedido();

            //expect
            expect(focaModalService.alert).toHaveBeenCalledWith('Ingrese Cliente');
        });

        it('funcion $scope.crearNotaPedido muestra alerta cuando proveedor es null', function() {

            //arrange
            var scope = {};
            var focaModalService = {
                alert: function() { }
            };

            $controler('notaPedidoCtrl', {
                $scope: scope,
                $uibModal: {},
                $location: {},
                $filter: filter,
                $timeout: timeout,
                crearNotaPedidoService: {
                    getBotonera: function() { },
                    getCotizacionByIdMoneda: function() {
                        return {
                            then: function() {}
                        };
                    }
                },
                focaBotoneraLateralService: {},
                focaModalService: focaModalService,
                notaPedidoBusinessService: {},
                $rootScope: {
                    $on: function() { }
                },
                focaSeguimientoService: {},
                APP: {},
                focaLoginService: {}
            });

            scope.notaPedido = {
                vendedor: {
                    id: true
                },
                cliente:{
                    COD: true
                },
                proveedor:{
                    COD: null
                }
            };

            //act
            spyOn(focaModalService, 'alert');
            scope.crearNotaPedido();

            //expect
            expect(focaModalService.alert).toHaveBeenCalledWith('Ingrese Proveedor');
        });

        it('funcion $scope.crearNotaPedido muestra alerta cuando Moneda es null', function() {

            //arrange
            var scope = {};
            var focaModalService = {
                alert: function() { }
            };

            $controler('notaPedidoCtrl', {
                $scope: scope,
                $uibModal: {},
                $location: {},
                $filter: filter,
                $timeout: timeout,
                crearNotaPedidoService: {
                    getBotonera: function() { },
                    getCotizacionByIdMoneda: function() {
                        return {
                            then: function() {}
                        };
                    }
                },
                focaBotoneraLateralService: {},
                focaModalService: focaModalService,
                notaPedidoBusinessService: {},
                $rootScope: {
                    $on: function() { }
                },
                focaSeguimientoService: {},
                APP: {},
                focaLoginService: {}
            });

            scope.notaPedido = {
                vendedor: {
                    id: true
                },
                cliente:{
                    COD: true
                },
                proveedor:{
                    COD: true
                },
                moneda:{
                    ID: null
                }
            };

            //act
            spyOn(focaModalService, 'alert');
            scope.crearNotaPedido();

            //expect
            expect(focaModalService.alert).toHaveBeenCalledWith('Ingrese Moneda');
        });

        it('funcion $scope.crearNotaPedido muestra alerta cuando cotizacion es null', function() {

            //arrange
            var scope = {};
            var focaModalService = {
                alert: function() { }
            };

            $controler('notaPedidoCtrl', {
                $scope: scope,
                $uibModal: {},
                $location: {},
                $filter: filter,
                $timeout: timeout,
                crearNotaPedidoService: {
                    getBotonera: function() { },
                    getCotizacionByIdMoneda: function() {
                        return {
                            then: function() {}
                        };
                    }
                },
                focaBotoneraLateralService: {},
                focaModalService: focaModalService,
                notaPedidoBusinessService: {},
                $rootScope: {
                    $on: function() { }
                },
                focaSeguimientoService: {},
                APP: {},
                focaLoginService: {}
            });

            scope.notaPedido = {
                vendedor: {
                    id: true
                },
                cliente:{
                    COD: true
                },
                proveedor:{
                    COD: true
                },
                moneda:{
                    ID: true
                },
                cotizacion:{
                    ID: null
                }
            };

            //act
            spyOn(focaModalService, 'alert');
            scope.crearNotaPedido();

            //expect
            expect(focaModalService.alert).toHaveBeenCalledWith('Ingrese Cotización');
        });

        it('funcion $scope.crearNotaPedido muestra alerta cuando plazos es null', function() {

            //arrange
            var scope = {};
            var focaModalService = {
                alert: function() { }
            };

            $controler('notaPedidoCtrl', {
                $scope: scope,
                $uibModal: {},
                $location: {},
                $filter: filter,
                $timeout: timeout,
                crearNotaPedidoService: {
                    getBotonera: function() { },
                    getCotizacionByIdMoneda: function() {
                        return {
                            then: function() {}
                        };
                    }
                },
                focaBotoneraLateralService: {},
                focaModalService: focaModalService,
                notaPedidoBusinessService: {},
                $rootScope: {
                    $on: function() { }
                },
                focaSeguimientoService: {},
                APP: {},
                focaLoginService: {}
            });

            scope.notaPedido = {
                vendedor: {
                    id: true
                },
                cliente:{
                    COD: true
                },
                proveedor:{
                    COD: true
                },
                moneda:{
                    ID: true
                },
                cotizacion:{
                    ID: true
                }
            };

            scope.plazosPagos = null;

            //act
            spyOn(focaModalService, 'alert');
            scope.crearNotaPedido();

            //expect
            expect(focaModalService.alert).toHaveBeenCalledWith('Ingrese Precios y Condiciones');
        });

        it('funcion $scope.crearNotaPedido muestra alerta cuando flete es null', function() {

            //arrange
            var scope = {};
            var focaModalService = {
                alert: function() { }
            };

            $controler('notaPedidoCtrl', {
                $scope: scope,
                $uibModal: {},
                $location: {},
                $filter: filter,
                $timeout: timeout,
                crearNotaPedidoService: {
                    getBotonera: function() { },
                    getCotizacionByIdMoneda: function() {
                        return {
                            then: function() {}
                        };
                    }
                },
                focaBotoneraLateralService: {},
                focaModalService: focaModalService,
                notaPedidoBusinessService: {},
                $rootScope: {
                    $on: function() { }
                },
                focaSeguimientoService: {},
                APP: {},
                focaLoginService: {}
            });

            scope.notaPedido = {
                vendedor: {
                    id: true
                },
                cliente:{
                    COD: true
                },
                proveedor:{
                    COD: true
                },
                moneda:{
                    ID: true
                },
                cotizacion:{
                    ID: true
                },
                flete: null
            };

            scope.plazosPagos = true;

            //act
            spyOn(focaModalService, 'alert');
            scope.crearNotaPedido();

            //expect
            expect(focaModalService.alert).toHaveBeenCalledWith('Ingrese Flete');
        });

        it('funcion $scope.crearNotaPedido muestra alerta cuando domicilio es null', function() {

            //arrange
            var scope = {};
            var focaModalService = {
                alert: function() { }
            };

            $controler('notaPedidoCtrl', {
                $scope: scope,
                $uibModal: {},
                $location: {},
                $filter: filter,
                $timeout: timeout,
                crearNotaPedidoService: {
                    getBotonera: function() { },
                    getCotizacionByIdMoneda: function() {
                        return {
                            then: function() {}
                        };
                    }
                },
                focaBotoneraLateralService: {},
                focaModalService: focaModalService,
                notaPedidoBusinessService: {},
                $rootScope: {
                    $on: function() { }
                },
                focaSeguimientoService: {},
                APP: {},
                focaLoginService: {}
            });

            scope.notaPedido = {
                vendedor: {
                    id: true
                },
                cliente:{
                    COD: true
                },
                proveedor:{
                    COD: true
                },
                moneda:{
                    ID: true
                },
                cotizacion:{
                    ID: true
                },
                flete: true,
                domicilioStamp: null
            };

            scope.plazosPagos = true;

            //act
            spyOn(focaModalService, 'alert');
            scope.crearNotaPedido();

            //expect
            expect(focaModalService.alert).toHaveBeenCalledWith('Ingrese Domicilio');
        });

        it('funcion $scope.crearNotaPedido muestra alerta cuando no se cargaron articulos',
            function()
        {

            //arrange
            var scope = {};
            var focaModalService = {
                alert: function() { }
            };

            $controler('notaPedidoCtrl', {
                $scope: scope,
                $uibModal: {},
                $location: {},
                $filter: filter,
                $timeout: timeout,
                crearNotaPedidoService: {
                    getBotonera: function() { },
                    getCotizacionByIdMoneda: function() {
                        return {
                            then: function() {}
                        };
                    }
                },
                focaBotoneraLateralService: {},
                focaModalService: focaModalService,
                notaPedidoBusinessService: {},
                $rootScope: {
                    $on: function() { }
                },
                focaSeguimientoService: {},
                APP: {},
                focaLoginService: {}
            });

            scope.notaPedido = {
                vendedor: {
                    id: true
                },
                cliente:{
                    COD: true
                },
                proveedor:{
                    COD: true
                },
                moneda:{
                    ID: true
                },
                cotizacion:{
                    ID: true
                },
                flete: true,
                domicilioStamp: true,
            };

            scope.plazosPagos = true;
            scope.articulosTabla = [];

            //act
            spyOn(focaModalService, 'alert');
            scope.crearNotaPedido();

            //expect
            expect(focaModalService.alert)
                .toHaveBeenCalledWith('Debe cargar al menos un articulo');
        });

        it('funcion $scope.crearNotaPedido llama startGuardar', function() {

            //arrange
            var scope = {};
            var focaBotoneraLateralService = {
                startGuardar: function() { }
            };

            $controler('notaPedidoCtrl', {
                $scope: scope,
                $uibModal: {},
                $location: {},
                $filter: filter,
                $timeout: timeout,
                crearNotaPedidoService: {
                    getBotonera: function() { },
                    getCotizacionByIdMoneda: function() {
                        return {
                            then: function() {}
                        };
                    },
                    crearNotaPedido: function() {
                        return {
                            then: function() { }
                        };
                    }
                },
                focaBotoneraLateralService: focaBotoneraLateralService,
                focaModalService: {},
                notaPedidoBusinessService: {},
                $rootScope: {
                    $on: function() { }
                },
                focaSeguimientoService: {},
                APP: {},
                focaLoginService: {}
            });

            scope.notaPedido = {
                vendedor: {
                    id: true
                },
                cliente:{
                    COD: true
                },
                proveedor:{
                    COD: true
                },
                moneda:{
                    ID: true
                },
                cotizacion:{
                    ID: true
                },
                flete: true,
                domicilioStamp: true,
                domicilio: {
                    id: true
                }
            };

            scope.plazosPagos = true;
            scope.articulosTabla = [1];

            //act
            spyOn(focaBotoneraLateralService, 'startGuardar');
            scope.crearNotaPedido();

            //expect
            expect(focaBotoneraLateralService.startGuardar).toHaveBeenCalled();
        });

        it('funcion $scope.crearNotaPedido llama funciones al guardar', function(done) {

            //arrange
            var scope = {};
            var focaBotoneraLateralService = {
                startGuardar: function() { },
                endGuardar: function() { }
            };
            var focaSeguimientoService = {
                guardarPosicion: function() { }
            };
            var notaPedidoBusinessService = {
                addArticulos: function() { },
                addEstado: function() { }
            };
            var crearNotaPedidoService = {
                getBotonera: function() { },
                getCotizacionByIdMoneda: function() {
                    return {
                        then: function() {}
                    };
                },
                crearNotaPedido: function() { },
                getNumeroNotaPedido: function() {
                    return {
                        then: function() { }
                    };
                }
            };

            $controler('notaPedidoCtrl', {
                $scope: scope,
                $uibModal: {},
                $location: {},
                $filter: filter,
                $timeout: timeout,
                crearNotaPedidoService: crearNotaPedidoService,
                focaBotoneraLateralService: focaBotoneraLateralService,
                focaModalService: {},
                notaPedidoBusinessService: notaPedidoBusinessService,
                $rootScope: {
                    $on: function() { }
                },
                focaSeguimientoService: focaSeguimientoService,
                APP: {},
                focaLoginService: {}
            });

            scope.notaPedido = {
                vendedor: {
                    id: true
                },
                cliente:{
                    COD: true
                },
                proveedor:{
                    COD: true
                },
                moneda:{
                    ID: true
                },
                cotizacion:{
                    ID: true
                },
                flete: true,
                domicilioStamp: true,
                domicilio: {
                    id: true
                }
            };

            scope.plazosPagos = [];
            scope.articulosTabla = [1];

            var promesa = Promise.resolve({ data: 1 });
            scope.$broadcast = function() { };

            //act
            spyOn(crearNotaPedidoService, 'crearNotaPedido').and.returnValue(promesa);
            spyOn(focaSeguimientoService, 'guardarPosicion');
            spyOn(notaPedidoBusinessService, 'addArticulos');
            scope.crearNotaPedido();

            //expect
            promesa.then(function() {
                expect(focaSeguimientoService.guardarPosicion).toHaveBeenCalled();
                expect(notaPedidoBusinessService.addArticulos).toHaveBeenCalled();
                done();
            });
        });
    });
});
